// FCC database access -*- C++ -*-

#include <string>
#include <iostream>
#include <sstream>
#include <fstream>

class Facility {
public:
  std::string assoc_facility_id;// The facility ID "associated" with the FX station (meaning, the facility_id that this FX station rebroadcasts)
  std::string callsign_eff_date;// The date the callsign became effective
  std::string comm_city;	// The city of the facility's "community served"
  std::string comm_state;	// The state of the facility's "community served"
  std::string digital_status;	// The digital status of the facility, D for Digital, H for Hybrid.
  std::string eeo_rpt_ind;	// Indicates whether the station plans to or does employ five or more employees
  std::string fac_address1;	// The address of the facility
  std::string fac_address2;	// The address of the facility, continued
  std::string fac_callsign;	// The call sign of the facility/station
  std::string fac_channel;	// Channel number
  std::string fac_city; 	// The city in which the facility is located. Also considered the Mailing City of the facility
  std::string fac_country;	// The country of the station
  std::string fac_frequency;	// The frequency assigned to the station
  std::string fac_service;	// Identifies the service which the facility supports
  std::string fac_state;	// The state in which the facility is located. The state of the mailing address.
  std::string fac_status;	// The facility status contains the last status of the facility application processing.
				// It may be CP granted, license granted, appeal pending, STA granted, silent
				// without STA, cancelled/deleted, etc.
  std::string fac_status_date;	// The date the facility status took effect
  std::string fac_type; 	// The type of the facility
  std::string fac_zip1; 	// The First 5 digits of the Zipcode of the facility
  std::string fac_zip2; 	// The second 5 digits of the Zipcode of the facility
  std::string facility_id;	// Uniquely identifies a facility
  std::string frn;		// FCC Registration Number
  std::string last_change_date;	// The date this record was last updated.
  std::string lic_expiration_date; // The date on which the FCC license or CP building permit expires
  std::string sat_tv;		// To designate satellite tv stations
  std::string station_type;	// Identifies the station as a main or an auxiliary
  std::string tsid_dtv; 	// The assigned unique digital Transport Stream Identifier.
  std::string tsid_ntsc;	// The assigned unique analog Transport Stream Identifier.
public:
  Facility(std::istream& in) {
    std::string buffer;
    getline(in, buffer);
    std::istringstream is(buffer);
    getline(is, comm_city, '|');
    getline(is, comm_state, '|');
    getline(is, eeo_rpt_ind, '|');
    getline(is, fac_address1, '|');
    getline(is, fac_address2, '|');
    getline(is, fac_callsign, '|');
    getline(is, fac_channel, '|');
    getline(is, fac_city, '|');
    getline(is, fac_country, '|');
    getline(is, fac_frequency, '|');
    getline(is, fac_service, '|');
    getline(is, fac_state, '|');
    getline(is, fac_status_date, '|');
    getline(is, fac_type, '|');
    getline(is, facility_id, '|');
    getline(is, lic_expiration_date, '|');
    getline(is, fac_status, '|');
    getline(is, fac_zip1, '|');
    getline(is, fac_zip2, '|');
    getline(is, station_type, '|');
    getline(is, assoc_facility_id, '|');
    getline(is, callsign_eff_date, '|');
    getline(is, tsid_ntsc, '|');
    getline(is, tsid_dtv, '|');
    getline(is, digital_status, '|');
    getline(is, sat_tv, '|');
    getline(is, last_change_date, '|');
  }
  void dump() {
    int i = 0;
#define out(s) std::cout << ++i << ' ' << #s << "=\"" << s << "\"\n";
    out(comm_city);
    out(comm_state);
    out(eeo_rpt_ind);
    out(fac_address1);
    out(fac_address2);
    out(fac_callsign);
    out(fac_channel);
    out(fac_city);
    out(fac_country);
    out(fac_frequency);
    out(fac_service);
    out(fac_state);
    out(fac_status_date);
    out(fac_type);
    out(facility_id);
    out(lic_expiration_date);
    out(fac_status);
    out(fac_zip1);
    out(fac_zip2);
    out(station_type);
    out(assoc_facility_id);
    out(callsign_eff_date);
    out(tsid_ntsc);
    out(tsid_dtv);
    out(digital_status);
    out(sat_tv);
    out(last_change_date);
#undef out
    std::cout << '\n';
  }
};

